// phone_wzero3.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"
#include <tapi.h>
#include "phone.h"
#include "CallLogRefMgr.h"
#include "CallLogRef.h"
#include "Debug.h"

/* Defines */
#define DENWA_WINDOW_CLASS_NAME		_T("AfxFrameOrView80su")
#define DENWA_WINDOW_TITLE_NAME		_T("db ")


HRESULT
PhoneOpenCallLog(
	HANDLE *phCallLog	// OUT
)
{
	HRESULT			hr;
	CCallLogRefMgr*	pMgr = NULL;
	CCallLogRef*	pRef = NULL;

	DEBUGLOG((_T("PhoneOpenCallLog: In, phCallLog=%08x"), phCallLog));

	hr = E_FAIL;	// default return value

	if (phCallLog == NULL) {
		DEBUGLOG((_T("PhoneOpenCallLog: Out, hr=%08x"), E_FAIL));
		return E_FAIL;
	}

	pMgr = CCallLogRefMgr::getInstance();
	if (pMgr != NULL) {
		pRef = pMgr->CreateRef();
		if (pRef != NULL) {
			if (pRef->Open()) {
				*phCallLog = (HANDLE)pRef;
				hr = S_OK;
			}
			else {
				pMgr->DeleteRef(pRef);
			}
		}
	}

	DEBUGLOG((_T("PhoneOpenCallLog: Out, hr=%08x"), hr));
	return hr;
}


HRESULT
PhoneGetCallLogEntry(
	HANDLE			hCallLog,	// IN
	PCALLLOGENTRY	pEntry		// OUT
)
{
	HRESULT			hr;
	CCallLogRefMgr*	pMgr = NULL;
	CCallLogRef*	pRef = NULL;
	CCallLogEntry*	pCallLogEntry = NULL;

	DEBUGLOG((_T("PhoneGetCallLogEntry: In, hCallLog=%08x, pEntry=%08x"), hCallLog, pEntry));

	hr = E_FAIL;	// default return value	

	if (hCallLog == NULL || pEntry == NULL) {
		DEBUGLOG((_T("PhoneGetCallLogEntry: Out, hr=%08x"), E_INVALIDARG));
		return E_INVALIDARG;
	}

	pMgr = CCallLogRefMgr::getInstance();
	if (pMgr != NULL) {
		pRef = (CCallLogRef*)hCallLog;
		if (pMgr->FindRef(pRef)) {
			BOOL	bGetSucc;
			bGetSucc = pRef->Get(&pCallLogEntry);
			if (bGetSucc) {
				if (pCallLogEntry != NULL) {
					if (pCallLogEntry->ConvertToCALLLOGENTRY(pEntry)) {
						hr = S_OK;
					}
				}
				else {
					hr = S_FALSE;
				}
			}
		}
	}

	DEBUGLOG((_T("PhoneGetCallLogEntry: Out, hr=%08x"), hr));
	return hr;
}

HRESULT
PhoneSeekCallLog(
	HANDLE		hCallLog,		// IN
	CALLLOGSEEK	seek,			// IN
	DWORD		iRecord,		// IN		
	LPDWORD		piRecord		// OUT
)
{
	HRESULT			hr;
	CCallLogRefMgr*	pMgr = NULL;
	CCallLogRef*	pRef = NULL;
	DWORD			dwFoundRecord = 0;

	DEBUGLOG((_T("PhoneSeekCallLogEntry: In, hCallLog=%08x, seek=%08x, iRecord=%08x, piRecord=%08x"), hCallLog, seek, iRecord, piRecord));

	hr = E_FAIL;	// default return value	

	if (hCallLog == NULL || piRecord == NULL) {
		DEBUGLOG((_T("PhoneSeekCallLogEntry: Out, hr=%08x"), E_FAIL));
		return E_FAIL;
	}

	pMgr = CCallLogRefMgr::getInstance();
	if (pMgr != NULL) {
		pRef = (CCallLogRef*)hCallLog;
		if (pMgr->FindRef(pRef)) {
			BOOL	bCanSeek = FALSE;

			switch(seek) {
			case CALLLOGSEEK_BEGINNING:
				bCanSeek = pRef->Seek(CALLLOG_REF_BEGINNING, iRecord, &dwFoundRecord);
				break;
			case CALLLOGSEEK_END:
				bCanSeek = pRef->Seek(CALLLOG_REF_END, iRecord, &dwFoundRecord);
				break;
			}

			if (bCanSeek) {
				*piRecord = dwFoundRecord;
				hr = S_OK;
			}
		}
	}

	DEBUGLOG((_T("PhoneSeekCallLogEntry: Out, hr=%08x"), hr));
	return hr;
}

HRESULT
PhoneCloseCallLog(
	HANDLE	hCallLog			// IN
)
{
	HRESULT			hr;
	CCallLogRefMgr*	pMgr = NULL;
	CCallLogRef*	pRef = NULL;

	DEBUGLOG((_T("PhoneCloseCallLog: In, hCallLog=%08x"), hCallLog));

	hr = E_FAIL;	// default return value	

	if (hCallLog == NULL) {
		DEBUGLOG((_T("PhoneCloseCallLog: Out, hr=%08x"), E_INVALIDARG));
		return E_INVALIDARG;
	}

	pMgr = CCallLogRefMgr::getInstance();
	if (pMgr != NULL) {
		pRef = (CCallLogRef*)hCallLog;
		if (pMgr->FindRef(pRef)) {
			pRef->Close();
			if (pMgr->DeleteRef(pRef)) {
				hr = S_OK;
			}
		}
	}

	DEBUGLOG((_T("PhoneCloseCallLog: Out, hr=%08x"), hr));
	return hr;
}


LONG
PhoneMakeCall(
	PHONEMAKECALLINFO *ppmci
)
{
	LONG	lResult;
	WCHAR	szURL[TAPIMAXDESTADDRESSSIZE + 16];

	lResult = -1;	// fail, default return value

	DEBUGLOG((_T("PhoneMakeCall: In, ppmci=%08x"), ppmci));

	if (ppmci == NULL) {
		DEBUGLOG((_T("PhoneMakeCall: Out, result=%08x"), lResult));
		return lResult;
	}

	if (ppmci->pszDestAddress != NULL) {
		SHELLEXECUTEINFO	sei;
		BOOL				bRet;

		wsprintf(szURL, _T("tel:%s"), ppmci->pszDestAddress);

		memset(&sei, 0, sizeof(sei));
		sei.cbSize = sizeof(sei);
		sei.fMask = SEE_MASK_NOCLOSEPROCESS;
		sei.hwnd = NULL;
		sei.lpVerb = _T("open");
		sei.lpFile = szURL;
		bRet = ShellExecuteEx(&sei);
		if (bRet) {
			CloseHandle(sei.hProcess);

			lResult = 0;
		}
	}

	DEBUGLOG((_T("PhoneMakeCall: Out, result=%08x"), lResult));
	return lResult;
}


HRESULT
PhoneAddSpeedDial(
   DWORD	dwFlags, 
   DWORD*	piKey, 
   const TCHAR*	pszDisplayName, 
   const TCHAR*	pszTelNumber
)
{
	HRESULT		hr;

	DEBUGLOG((_T("PhoneAddSpeedDial: In, dwFlags=%08x, piKey=%08x, pszDisplayName=%08x, pszTelNumber=%08x"), dwFlags, piKey, pszDisplayName, pszTelNumber));

#ifdef DEBUG
	if (pszDisplayName != NULL) {
		DEBUGLOG((_T("PhoneAddSpeedDial: pszDisplayName=%s"), pszDisplayName));
	}
	if (pszTelNumber != NULL) {
		DEBUGLOG((_T("PhoneAddSpeedDial: pszTelNumber=%s"), pszTelNumber));
	}
#endif

	hr = E_FAIL;	// default return value

	DEBUGLOG((_T("PhoneAddSpeedDial: Out, hr=%08x"), hr));

	return hr;
}


HRESULT
PhoneShowCallLog(
	CALLLOGFILTER iCallLogFilter
)
{
	HRESULT		hr;
	HWND		hWnd = NULL;

	hr = E_INVALIDARG;	// default return value

	DEBUGLOG((_T("PhoneShowCallLog: In, iCallLogFilter=%08x"), iCallLogFilter));

	switch(iCallLogFilter) {
	case CALLLOGFILTER_OUTGOING:
		// M
		{
			hWnd = FindWindow(DENWA_WINDOW_CLASS_NAME, DENWA_WINDOW_TITLE_NAME);

			if (hWnd != NULL) {
				SetForegroundWindow(hWnd);
				keybd_event(VK_F21,	0, KEYEVENTF_SILENT,0);
				keybd_event(VK_RIGHT, 0, KEYEVENTF_SILENT,0);
				keybd_event(VK_RIGHT, 0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
				keybd_event(VK_F21,	0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
			}
			hr = S_OK;
		}
		break;
	case CALLLOGFILTER_ALL_CALLS:
	case CALLLOGFILTER_MISSED:
	case CALLLOGFILTER_INCOMING:
		// SĒMɂ
		{
			hWnd = FindWindow(DENWA_WINDOW_CLASS_NAME, DENWA_WINDOW_TITLE_NAME);

			if (hWnd != NULL) {
				SetForegroundWindow(hWnd);
				keybd_event(VK_F21,	0, KEYEVENTF_SILENT,0);
				keybd_event(VK_LEFT, 0, KEYEVENTF_SILENT,0);
				keybd_event(VK_LEFT, 0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
				keybd_event(VK_F21,	0, KEYEVENTF_KEYUP|KEYEVENTF_SILENT,0);
			}
			hr = S_OK;
		}
		break;
	}

	DEBUGLOG((_T("PhoneShowCallLog: Out, hr=%08x"), hr));
	return hr;
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  dwReason, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

